#!/bin/bash

##########################################################################
#
# Organización del computador II - TP Final - SIMD sobre hashing.
#
# Experiencia algoritmo SHA-1 - Loop Unrolling
#
# Autor:  Pino, Jorge Daniel (LU 556/07) - JDanielPino@gmail.com
#
##########################################################################


APP_NAME="sha1" # Nombre de la aplicación.
N=6             # Número de iteraciones.

N_OUTPUT_FILENAME="normal_loop_out.dat"
U_OUTPUT_FILENAME="unrolled_loop_out.dat"

#
# Borramos cualquier archivo de datos preexistente.
#
rm -f $N_OUTPUT_FILENAME
rm -f $U_OUTPUT_FILENAME


for ((i=0; i < N; i++))
do

  #echo "Creando el archivo temporal..."
  #echo

  #
  # Generamos un nombre aleatorio para el archivo.
  #
  fileName="temp"$RANDOM".dat"

  #
  # Creamos el archivo.
  #
  size=$(( i+1 ))
  dd if=/dev/zero of="$fileName" bs=500M count=$size

  #
  # Obtenemos el directorio actual.
  #
  currentDir=$( pwd )

  #
  # Ejecutamos la aplicación para el caso normal (sin 'loop unrolling').
  #
  for ((j=0; j < N+1; j++))
  do
    ./$APP_NAME -n $fileName
  done

  #
  # Ejecutamos la aplicación para el caso optimizado (con 'loop unrolling').
  #
  for ((j=0; j < N+1; j++))
  do
    ./$APP_NAME -u $fileName
  done

  #
  # Eliminamos el archivo temporal.
  #
  rm $fileName

done

