#!/bin/bash

##########################################################################
#
# Organización del computador II - TP Final - SIMD sobre hashing.
#
# Experiencia algoritmo SHA-256
#
# Autor:  Pino, Jorge Daniel (LU 556/07) - JDanielPino@gmail.com
#
##########################################################################


APP_NAME="sha256" # Nombre de la aplicación.
N=6               # Número de iteraciones.

ASM_OUTPUT_FILENAME="sha256_asm_out.dat"
SIMD_OUTPUT_FILENAME="sha256_simd_out.dat"

#
# Borramos cualquier archivo de datos preexistente.
#
rm -f $ASM_OUTPUT_FILENAME
rm -f $SIMD_OUTPUT_FILENAME


for ((i=0; i < N; i++))
do

  #echo "Creando el archivo temporal..."
  #echo

  #
  # Generamos un nombre aleatorio para el archivo.
  #
  fileName="temp"$RANDOM".dat"

  #
  # Creamos el archivo.
  #
  size=$(( i+1 ))
  dd if=/dev/zero of="$fileName" bs=500M count=$size

  #
  # Obtenemos el directorio actual.
  #
  currentDir=$( pwd )

  #
  # Ejecutamos la aplicación para el caso escalar ASM.
  #
  for ((j=0; j < N+1; j++))
  do
    ./$APP_NAME -a $fileName
  done

  #
  # Ejecutamos la aplicación para el caso vectorizado SIMD.
  #
  for ((j=0; j < N+1; j++))
  do
    ./$APP_NAME -s $fileName
  done

  #
  # Eliminamos el archivo temporal.
  #
  rm $fileName

done

