//
// Alias para los tipos
//
typedef unsigned int  uint;
typedef unsigned long ulong;
typedef unsigned char uchar;

//
// Macros
//
#define ROTATE_LEFT(v, n) \
({\
  unsigned int _aux1, _aux2, _n; \
  _n = n % (sizeof(unsigned int)*8); \
  _aux1 = v << _n; \
  _aux2 = v >> ((sizeof(unsigned int)*8) - _n); \
  (_aux1 | _aux2); \
})

//
// Devuelve el hash SHA-1 de 160 bits.
//
// Parámetros:
//
// 1) uchar* buffer: puntero al buffer con los datos ya
//    rellenados con el 'padding'.
// 2) size_t size: tamaño en bytes del buffer.
// 3) uint hash[5]: vector donde la función devuelve el hash.
//
void get_sha1_c_normal_loop(uchar* buffer, size_t size, uint h[5]);

